/*
*  This script is the core of the Bookmark Duplicate Detector extension.
*
* Author: Stphane BERTIN
* http://bookmarkdd.mozdev.org
*
*/

//Test de remplacement
//PlacesUIUtils.showAddBookmarkUI = f_test ;
/*function f_test (aURI,
aTitle,
aDescription,
aDefaultInsertionPoint,
aShowPicker,
aLoadInSidebar,
aKeyword,
aPostData,
aCharSet) {
alert ("Parametres : "+aURI+ aTitle+ aDescription+ aDefaultInsertionPoint+ aShowPicker+ aLoadInSidebar+ aKeyword+ aPostData+ aCharSet);
}*/
//PlacesUIUtils.showAddBookmarkUI ("TEST_URI"+"toto"+"tutu"+null+null+null+null);
//
//


// Initiate bookmarks service to access all bookmarks methods
var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"]
    .getService(Components.interfaces.nsINavBookmarksService);
// Initiate livemarks service to access all livemarks methods
var livemarkService = Components.classes["@mozilla.org/browser/livemark-service;2"]
    .getService(Components.interfaces.nsILivemarkService);


// nsINavBookmarkObserver : Listener for Bookmarkdd extension
// Observer to listen changes related to bookmarks
var Bdd_bookmarkListener = {
    onBeginUpdateBatch: function() {},
    onEndUpdateBatch: function() {},
    onItemAdded: function(aItemId, aFolder, aIndex) {
	Bookmarkdd.doItemAdded(aItemId,aFolder,aIndex);
    },
    onItemRemoved: function(aItemId, aFolder, aIndex) {},
    onItemChanged: function(aBookmarkId, aProperty, aIsAnnotationProperty, aValue) {
	//Bookmarkdd.doSomething(aBookmarkId,aValue,"Changed");
    },
    onItemVisited: function(aBookmarkId, aVisitID, time) {},
    onItemMoved: function(aItemId, aOldParent, aOldIndex, aNewParent, aNewIndex) {
	// If a bookmark is moved in the same folder do not try to detect duplicates
	// Move in same folder happened with 'sort in folder'
	//TODO : sort in bookmark sideBar trigger this !!!!!
	if (aOldParent != aNewParent) { Bookmarkdd.doItemAdded(aItemId,aNewParent,aNewIndex); }
    },
    QueryInterface: function(iid) {
	if (iid.equals(Ci.nsINavBookmarkObserver) || iid.equals(Ci.nsISupports)) {
	    return this;
	}
	throw Cr.NS_ERROR_NO_INTERFACE;
    }
};

// Extension Object
var Bookmarkdd = {

    // Property used with BddConfirmWindow.xul to get user choice
    userResponse: false,

    // Property used to trace some events during development
    DEBUG: true,

    // Method used to load Bdd Observer
    onLoad: function() {
	bmsvc.addObserver(Bdd_bookmarkListener, false);
    },
 
    // Method used to Unload Bdd Observer
    onUnLoad: function() {
	bmsvc.removeObserver(Bdd_bookmarkListener);
    },

    // Method called by Bdd Observer when an item is added in bookmarks
    doItemAdded: function(aItemId,aFolderId,aIndex) {
	var thisURI = bmsvc.getBookmarkURI(aItemId);
	var itemType = bmsvc.getItemType(aItemId);
	//TYPE_BOOKMARK 	 1 	This is an index for type "Bookmark".
	//TYPE_FOLDER 	2 	This is an index for type "Folder".
	//TYPE_SEPARATOR 	3 	This is an index for type "Separator".
	//TYPE_DYNAMIC_CONTAINER  4 	This is an index for type "Dynamic Container".

	if (itemType == 1) {
	    var livemarkCheck = livemarkService.isLivemark(aFolderId); //if livemark return true
	    if (!livemarkCheck && !isItaTag(aItemId)) {
		var bookmarksIdsForURI = bmsvc.getBookmarkIdsForURI(thisURI, {});
		if (bookmarksIdsForURI.length > 1) { // >1 then URL is duplicated
		    // Function used to filter aItemId and Tagged bookmarks in the array
		    function deleteElt(element, index, array) {
			if (element == aItemId) { return false; }
			if (isItaTag(element)) { return false; }
			return true;
		    }
		    var truncatedArray=bookmarksIdsForURI.filter(deleteElt);

		    var parentFoldersId = truncatedArray.map(bmsvc.getFolderIdForItem);
		    var parentTitle = parentFoldersId.map(this.findPath); 

		    var DuplicatesBundle = document.getElementById('duplicates-strings');
		    if (!DuplicatesBundle) { // Is it necessary ??????
			// Used by BookmarksPanelOverlay
			DuplicatesBundle = top.document.getElementById('duplicates-strings');
		    }
		    if (DuplicatesBundle){
			var message = DuplicatesBundle.getString("alreadyIn-Folder")+"\n";
			message += parentTitle.join("\n")+"\n";
			message += DuplicatesBundle.getString("alreadyIn-Confirm");
		    } else {
			var message = Bookmarkdd.searchStringLocalisation("alreadyIn-Folder")+"\n";
			message += parentTitle.join("\n")+"\n";
			message += Bookmarkdd.searchStringLocalisation("alreadyIn-Confirm");
		    }

		    // true -> keep duplicate bookmark
		    // false -> delete item because it is already created when the method is called by Observer
		    if(! BddConfirm(message)) bmsvc.removeItem(aItemId);

		    // I don't know the role of this method ???
		    //var stringF = PlacesUtils.getQueryStringForFolder(aFolderId);
		}
	    } // else the item is a Livemark
	} else { // The item is not a bookmark
	    if(this.DEBUG) { this.myDump("Bdd added item is :\nType="+itemType+"\nUri="+thisURI.spec); }
	}

    },
    /*
     * Method used to get the path of a folder Id.
     * If argument is not a folder -> return the ItemTitle
     * input argument : 
     * afolderId = a Folder Id
     * ouput : Return a chain of URL Parent Folder Name
     */
    findPath : function(afolderId) {
	var folderPath = new Array();
	var boucle = true;
	var itemType = bmsvc.getItemType(afolderId);

	// If argument is not a folder we do not try to find folder parent but return the ItemTitle
	if (itemType != 2) {
	    boucle = false;
	    //alert("FindPath: argument is not a Folder = "+bmsvc.getItemTitle(afolderId));
	} else {
	    folderPath.push(bmsvc.getItemTitle(afolderId)); 
	}

	// If it is an attribute folder stop the loop : the last afolderID is an attribute folder
	boucle = (isAttributeFolder(afolderId)) ? false : true;

	while (boucle){
	    afolderId = bmsvc.getFolderIdForItem(afolderId);
	    folderPath.push(bmsvc.getItemTitle(afolderId)); 
	    // If it is an attribute folder stop the loop : the last afolderID is an attribute folder
	    boucle = (isAttributeFolder(afolderId)) ? false : true;
	}
	folderPath.reverse();

	//alert("folderPath : "+folderPath.join(" > "));
	return folderPath.join(" > ");
    },

    //Function used to log message within JS Console
    myDump: function (aMessage) 
    {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
				 .getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage("BookmarkDD's message: " + aMessage);
    },

    // Function used to find localized Strings due to restriction of overlay: element in overlay have no ID !!
    // Insertion of <stringbundle id="duplicates-strings"/> can't be called !!!!!
    searchStringLocalisation: function (aLabel){
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		    .getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator("");

	while(enumerator.hasMoreElements()) {
	    var win = enumerator.getNext();
	    // |win| is [Object ChromeWindow] (just like |window|), do something with it
	    var duplicatesStrings=win.document.getElementById("duplicates-strings");
	    if(duplicatesStrings) {
		return duplicatesStrings.getString(aLabel);
	    }
	}
	return false;
    }
};

// Test to know if argument is an 'attribute folder' of Bookmarks service
// Attributes folder are : bookmarksMenuFolder, tagsFolder, unfiledBookmarksFolder, toolbarFolder and the parent placesRoot
// return true or false
function isAttributeFolder(aFolderId){
    if (aFolderId == bmsvc.unfiledBookmarksFolder || 
	aFolderId == bmsvc.bookmarksMenuFolder || 
	aFolderId == bmsvc.toolbarFolder ||
	aFolderId == bmsvc.tagsFolder || 
	aFolderId == bmsvc.placesRoot ) {
	return true;
    } else {
	return false;
    }
}

// Function used to test if the bookmark is in Tag folder
function isItaTag(aItemID){
    var IdtoTest = aItemID;
    // If it is an attribute folder stop the loop : the last afolderID is an attribute folder
    var boucle = (isAttributeFolder(aItemID)) ? false : true;
    var result = false;

    while (boucle){
	IdtoTest = bmsvc.getFolderIdForItem(IdtoTest);
	// If it is an attribute folder stop the loop : the last afolderID is an attribute folder
	boucle = (isAttributeFolder(IdtoTest)) ? false : true;
    }
    if (IdtoTest == bmsvc.tagsFolder) {
	result=true;
    }
    if(Bookmarkdd.DEBUG) { Bookmarkdd.myDump("itemId :"+aItemID+" isItaTag = "+result+"\nPath='"+Bookmarkdd.findPath(aItemID)+"'"); }
    return result;
}

//BookmarkDD uses its own confirm window to replace default icon without overlay icon for all Browser's confirm
// Params :
// aText = message to show in dialog box
// aModal = the dialog Box is modal or not
// By default it is not modal
function BddConfirm(aText,aModal){

    //alert("aModal="+aModal+"\naText = "+aText);
    if (aModal) {
	window.openDialog("chrome://duplicates/content/Fx3/ConfirmOverlay.xul", "BookmarkDD-Confirm", "chrome,modal,alwaysRaised,resizable,centerscreen", aText);
    } else {
	window.openDialog("chrome://duplicates/content/Fx3/ConfirmOverlay.xul", "BookmarkDD-Confirm", "chrome,alwaysRaised,resizable,centerscreen", aText);
    }

    return Bookmarkdd.userResponse;
}
